diff --git a/pimd/pim_iface.c b/pimd/pim_iface.c
index db9156b04b55..0f8485bed9f4 100644
--- a/pimd/pim_iface.c
+++ b/pimd/pim_iface.c
@@ -720,10 +720,17 @@ static void pim_if_addr_del_pim(struct connected *ifc)
 void pim_if_addr_del(struct connected *ifc, int force_prim_as_any)
 {
 	struct interface *ifp;
+	struct pim_interface *pim_ifp;
+        struct pim_upstream *up;
+        struct listnode *node;
+        struct rp_info *rp_info;
+	struct pim_instance *pim;
 
 	assert(ifc);
 	ifp = ifc->ifp;
 	assert(ifp);
+	pim_ifp = ifp->info;
+	pim = pim_ifp->pim;
 
 	if (PIM_DEBUG_ZEBRA)
 		zlog_debug("%s: %s ifindex=%d disconnected IP address %pFX %s",
@@ -733,8 +740,6 @@ void pim_if_addr_del(struct connected *ifc, int force_prim_as_any)
 				   : "primary");
 
 #if PIM_IPV == 6
-	struct pim_interface *pim_ifp = ifc->ifp->info;
-
 	if (pim_ifp &&
 	    (!IPV6_ADDR_CMP(&ifc->address->u.prefix6, &pim_ifp->ll_lowest) ||
 	     !IPV6_ADDR_CMP(&ifc->address->u.prefix6, &pim_ifp->ll_highest))) {
@@ -770,6 +775,12 @@ void pim_if_addr_del(struct connected *ifc, int force_prim_as_any)
 		gm_ifp_update(ifp);
 	}
 #endif
+	for (ALL_LIST_ELEMENTS_RO(pim->rp_list, node, rp_info)) {
+		if (rp_info->rp.source_nexthop.interface &&
+		    rp_info->rp.source_nexthop.interface == ifp) {
+			pim_rp_nexthop_del(rp_info);
+		}
+	}
 
 	detect_address_change(ifp, force_prim_as_any, __func__);
 
